
package de.ivu.elect.presentation.kandidatur.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;

import de.ivu.elect.business.kandidatur.entity.Direktkandidatur;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahlvorschlag.boundary.WahlvorschlagConversationSelect;
import de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonConstants;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;
import de.ivu.elect.presentation.wahlvorschlagsperson.WahlvorschlagsPersonSearchView;

public class DirektkandidaturWahlvorschlagsPersonSearchAction extends AbstractDirektkandidaturAction {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient WahlvorschlagConversationSelect wahlvorschlagConversationSelect;

  public DirektkandidaturWahlvorschlagsPersonSearchAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAHLVORSCHLAGS_PERSON_SEARCH;
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getEinsehenGebietSecurity();
  }

  @Override
  protected boolean isDisabledInternal(Direktkandidatur direktkandidatur) {
    return isNurWas() || isWaehlerBenannteDirektkandidatur(direktkandidatur);
  }

  @Override
  protected String doIt(@Nonnull Direktkandidatur direktkandidatur) {
    wahlvorschlagConversationSelect.setEntity(direktkandidatur.getDirektkandidat());

    return WahlvorschlagsPersonSearchView.VIEW_ID;
  }

  @Override
  protected String getLocalizedLabel() {
    return getMessage(getLabelKey(), getMessage(WahlvorschlagsPersonConstants.MESSAGE_KEY_ENTITY_MEHRZAHL));
  }

  @Override
  public String getLabelKey() {
    return "entity.search.menu.item.label";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconSearch();
  }
}
